diff a/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.cpp b/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.cpp
--- a/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.cpp
+++ b/src/hotspot/share/gc/shenandoah/c2/shenandoahBarrierSetC2.cpp
@@ -541,291 +177,213 @@
   const TypeTuple *range = TypeTuple::make(TypeFunc::Parms+0, fields);
 
   return TypeFunc::make(domain, range);
 }
 
-const TypeFunc* ShenandoahBarrierSetC2::load_reference_barrier_Type() {
-  const Type **fields = TypeTuple::fields(2);
-  fields[TypeFunc::Parms+0] = TypeOopPtr::BOTTOM; // original field value
-  fields[TypeFunc::Parms+1] = TypeRawPtr::BOTTOM; // original load address
+static uint8_t get_store_barrier(C2Access& access) {
+  if (!access.is_parse_access()) {
+    // Only support for eliding barriers at parse time for now.
+    return ShenandoahBarrierSATB | ShenandoahBarrierCardMark;
+  }
+  GraphKit* kit = (static_cast<C2ParseAccess&>(access)).kit();
+  Node* ctl = kit->control();
+  Node* adr = access.addr().node();
+  uint adr_idx = kit->C->get_alias_index(access.addr().type());
+  assert(adr_idx != Compile::AliasIdxTop, "use other store_to_memory factory");
 
-  const TypeTuple *domain = TypeTuple::make(TypeFunc::Parms+2, fields);
+  bool can_remove_pre_barrier = satb_can_remove_pre_barrier(kit, &kit->gvn(), adr, access.type(), adr_idx);
 
-  // create result type (range)
-  fields = TypeTuple::fields(1);
-  fields[TypeFunc::Parms+0] = TypeOopPtr::BOTTOM;
-  const TypeTuple *range = TypeTuple::make(TypeFunc::Parms+1, fields);
+  // We can skip marks on a freshly-allocated object in Eden. Keep this code in
+  // sync with CardTableBarrierSet::on_slowpath_allocation_exit. That routine
+  // informs GC to take appropriate compensating steps, upon a slow-path
+  // allocation, so as to make this card-mark elision safe.
+  // The post-barrier can also be removed if null is written. This case is
+  // handled by ShenandoahBarrierSetC2::expand_barriers, which runs at the end of C2's
+  // platform-independent optimizations to exploit stronger type information.
+  bool can_remove_post_barrier = ReduceInitialCardMarks &&
+    ((access.base() == kit->just_allocated_object(ctl)) ||
+     shenandoah_can_remove_post_barrier(kit, &kit->gvn(), ctl, adr));
 
-  return TypeFunc::make(domain, range);
+  int barriers = 0;
+  if (!can_remove_pre_barrier) {
+    barriers |= ShenandoahBarrierSATB;
+  }
+  if (!can_remove_post_barrier) {
+    barriers |= ShenandoahBarrierCardMark;
+  }
+
+  return barriers;
 }
 
 Node* ShenandoahBarrierSetC2::store_at_resolved(C2Access& access, C2AccessValue& val) const {
   DecoratorSet decorators = access.decorators();
-
-  const TypePtr* adr_type = access.addr().type();
-  Node* adr = access.addr().node();
-
+  bool anonymous = (decorators & ON_UNKNOWN_OOP_REF) != 0;
+  bool in_heap = (decorators & IN_HEAP) != 0;
+  bool tightly_coupled_alloc = (decorators & C2_TIGHTLY_COUPLED_ALLOC) != 0;
+  bool need_store_barrier = !(tightly_coupled_alloc && ReduceInitialCardMarks) && (in_heap || anonymous);
   bool no_keepalive = (decorators & AS_NO_KEEPALIVE) != 0;
-
-  if (!access.is_oop()) {
-    return BarrierSetC2::store_at_resolved(access, val);
+  if (access.is_oop() && need_store_barrier) {
+    access.set_barrier_data(get_store_barrier(access));
+    if (tightly_coupled_alloc) {
+      assert(!ReduceInitialCardMarks,
+             "post-barriers are only needed for tightly-coupled initialization stores when ReduceInitialCardMarks is disabled");
+      // Pre-barriers are unnecessary for tightly-coupled initialization stores.
+      access.set_barrier_data(access.barrier_data() & ~ShenandoahBarrierSATB);
+    }
   }
-
   if (no_keepalive) {
     // No keep-alive means no need for the pre-barrier.
-    return BarrierSetC2::store_at_resolved(access, val);
+    access.set_barrier_data(access.barrier_data() & ~ShenandoahBarrierSATB);
   }
+  return BarrierSetC2::store_at_resolved(access, val);
+}
 
-  if (access.is_parse_access()) {
-    C2ParseAccess& parse_access = static_cast<C2ParseAccess&>(access);
-    GraphKit* kit = parse_access.kit();
+static void set_barrier_data(C2Access& access) {
+  if (!access.is_oop()) {
+    return;
+  }
 
-    uint adr_idx = kit->C->get_alias_index(adr_type);
-    assert(adr_idx != Compile::AliasIdxTop, "use other store_to_memory factory" );
-    shenandoah_write_barrier_pre(kit, true /* do_load */, /*kit->control(),*/ access.base(), adr, adr_idx, val.node(),
-                                 static_cast<const TypeOopPtr*>(val.type()), nullptr /* pre_val */, access.type());
+  if (access.decorators() & C2_TIGHTLY_COUPLED_ALLOC) {
+    access.set_barrier_data(ShenandoahBarrierElided);
+    return;
+  }
 
-    Node* result = BarrierSetC2::store_at_resolved(access, val);
+  uint8_t barrier_data = 0;
 
-    if (ShenandoahCardBarrier) {
-      const bool anonymous = (decorators & ON_UNKNOWN_OOP_REF) != 0;
-      const bool is_array = (decorators & IS_ARRAY) != 0;
-      const bool use_precise = is_array || anonymous;
-      post_barrier(kit, kit->control(), access.raw_access(), access.base(),
-                   adr, adr_idx, val.node(), access.type(), use_precise);
-    }
-    return result;
+  if (access.decorators() & ON_PHANTOM_OOP_REF) {
+    barrier_data |= ShenandoahBarrierPhantom;
+  } else if (access.decorators() & ON_WEAK_OOP_REF) {
+    barrier_data |= ShenandoahBarrierWeak;
   } else {
-    assert(access.is_opt_access(), "only for optimization passes");
-    assert(((decorators & C2_TIGHTLY_COUPLED_ALLOC) != 0 || !ShenandoahSATBBarrier) && (decorators & C2_ARRAY_COPY) != 0, "unexpected caller of this code");
-    return BarrierSetC2::store_at_resolved(access, val);
+    barrier_data |= ShenandoahBarrierStrong;
+  }
+
+  if (access.decorators() & IN_NATIVE) {
+    barrier_data |= ShenandoahBarrierNative;
   }
+
+  access.set_barrier_data(barrier_data);
 }
 
 Node* ShenandoahBarrierSetC2::load_at_resolved(C2Access& access, const Type* val_type) const {
   // 1: non-reference load, no additional barrier is needed
   if (!access.is_oop()) {
     return BarrierSetC2::load_at_resolved(access, val_type);
   }
 
-  Node* load = BarrierSetC2::load_at_resolved(access, val_type);
-  DecoratorSet decorators = access.decorators();
-  BasicType type = access.type();
-
-  // 2: apply LRB if needed
-  if (ShenandoahBarrierSet::need_load_reference_barrier(decorators, type)) {
-    load = new ShenandoahLoadReferenceBarrierNode(nullptr, load, decorators);
-    if (access.is_parse_access()) {
-      load = static_cast<C2ParseAccess &>(access).kit()->gvn().transform(load);
-    } else {
-      load = static_cast<C2OptAccess &>(access).gvn().transform(load);
-    }
-  }
+  // 2. Set barrier data for LRB.
+  set_barrier_data(access);
 
-  // 3: apply keep-alive barrier for java.lang.ref.Reference if needed
-  if (ShenandoahBarrierSet::need_keep_alive_barrier(decorators, type)) {
-    Node* top = Compile::current()->top();
-    Node* adr = access.addr().node();
-    Node* offset = adr->is_AddP() ? adr->in(AddPNode::Offset) : top;
-    Node* obj = access.base();
-
-    bool unknown = (decorators & ON_UNKNOWN_OOP_REF) != 0;
-    bool on_weak_ref = (decorators & (ON_WEAK_OOP_REF | ON_PHANTOM_OOP_REF)) != 0;
-    bool keep_alive = (decorators & AS_NO_KEEPALIVE) == 0;
-
-    // If we are reading the value of the referent field of a Reference
-    // object (either by using Unsafe directly or through reflection)
-    // then, if SATB is enabled, we need to record the referent in an
-    // SATB log buffer using the pre-barrier mechanism.
-    // Also we need to add memory barrier to prevent commoning reads
-    // from this field across safepoint since GC can change its value.
-    if (!on_weak_ref || (unknown && (offset == top || obj == top)) || !keep_alive) {
-      return load;
-    }
-
-    assert(access.is_parse_access(), "entry not supported at optimization time");
-    C2ParseAccess& parse_access = static_cast<C2ParseAccess&>(access);
-    GraphKit* kit = parse_access.kit();
-    bool mismatched = (decorators & C2_MISMATCHED) != 0;
-    bool is_unordered = (decorators & MO_UNORDERED) != 0;
-    bool in_native = (decorators & IN_NATIVE) != 0;
-    bool need_cpu_mem_bar = !is_unordered || mismatched || in_native;
-
-    if (on_weak_ref) {
-      // Use the pre-barrier to record the value in the referent field
-      satb_write_barrier_pre(kit, false /* do_load */,
-                             nullptr /* obj */, nullptr /* adr */, max_juint /* alias_idx */, nullptr /* val */, nullptr /* val_type */,
-                             load /* pre_val */, T_OBJECT);
-      // Add memory barrier to prevent commoning reads from this field
-      // across safepoint since GC can change its value.
-      kit->insert_mem_bar(Op_MemBarCPUOrder);
-    } else if (unknown) {
-      // We do not require a mem bar inside pre_barrier if need_mem_bar
-      // is set: the barriers would be emitted by us.
-      insert_pre_barrier(kit, obj, offset, load, !need_cpu_mem_bar);
-    }
+  // 3. If we are reading the value of the referent field of a Reference object, we
+  // need to record the referent in an SATB log buffer using the pre-barrier
+  // mechanism.
+  DecoratorSet decorators = access.decorators();
+  bool on_weak = (decorators & ON_WEAK_OOP_REF) != 0;
+  bool on_phantom = (decorators & ON_PHANTOM_OOP_REF) != 0;
+  bool no_keepalive = (decorators & AS_NO_KEEPALIVE) != 0;
+  // If we are reading the value of the referent field of a Reference object, we
+  // need to record the referent in an SATB log buffer using the pre-barrier
+  // mechanism. Also we need to add a memory barrier to prevent commoning reads
+  // from this field across safepoints, since GC can change its value.
+  uint8_t barriers = access.barrier_data();
+  bool need_read_barrier = ((on_weak || on_phantom) && !no_keepalive);
+  if (access.is_oop() && need_read_barrier) {
+    barriers |= ShenandoahBarrierSATB;
   }
+  access.set_barrier_data(barriers);
 
-  return load;
+  return BarrierSetC2::load_at_resolved(access, val_type);
 }
 
 Node* ShenandoahBarrierSetC2::atomic_cmpxchg_val_at_resolved(C2AtomicParseAccess& access, Node* expected_val,
                                                              Node* new_val, const Type* value_type) const {
-  GraphKit* kit = access.kit();
-  if (access.is_oop()) {
-    shenandoah_write_barrier_pre(kit, false /* do_load */,
-                                 nullptr, nullptr, max_juint, nullptr, nullptr,
-                                 expected_val /* pre_val */, T_OBJECT);
-
-    MemNode::MemOrd mo = access.mem_node_mo();
-    Node* mem = access.memory();
-    Node* adr = access.addr().node();
-    const TypePtr* adr_type = access.addr().type();
-    Node* load_store = nullptr;
-
-#ifdef _LP64
-    if (adr->bottom_type()->is_ptr_to_narrowoop()) {
-      Node *newval_enc = kit->gvn().transform(new EncodePNode(new_val, new_val->bottom_type()->make_narrowoop()));
-      Node *oldval_enc = kit->gvn().transform(new EncodePNode(expected_val, expected_val->bottom_type()->make_narrowoop()));
-      if (ShenandoahCASBarrier) {
-        load_store = kit->gvn().transform(new ShenandoahCompareAndExchangeNNode(kit->control(), mem, adr, newval_enc, oldval_enc, adr_type, value_type->make_narrowoop(), mo));
-      } else {
-        load_store = kit->gvn().transform(new CompareAndExchangeNNode(kit->control(), mem, adr, newval_enc, oldval_enc, adr_type, value_type->make_narrowoop(), mo));
-      }
-    } else
-#endif
-    {
-      if (ShenandoahCASBarrier) {
-        load_store = kit->gvn().transform(new ShenandoahCompareAndExchangePNode(kit->control(), mem, adr, new_val, expected_val, adr_type, value_type->is_oopptr(), mo));
-      } else {
-        load_store = kit->gvn().transform(new CompareAndExchangePNode(kit->control(), mem, adr, new_val, expected_val, adr_type, value_type->is_oopptr(), mo));
-      }
-    }
-
-    access.set_raw_access(load_store);
-    pin_atomic_op(access);
+  if (ShenandoahCASBarrier) {
+    set_barrier_data(access);
+  }
 
-#ifdef _LP64
-    if (adr->bottom_type()->is_ptr_to_narrowoop()) {
-      load_store = kit->gvn().transform(new DecodeNNode(load_store, load_store->get_ptr_type()));
-    }
-#endif
-    load_store = kit->gvn().transform(new ShenandoahLoadReferenceBarrierNode(nullptr, load_store, access.decorators()));
-    if (ShenandoahCardBarrier) {
-      post_barrier(kit, kit->control(), access.raw_access(), access.base(),
-                   access.addr().node(), access.alias_idx(), new_val, T_OBJECT, true);
-    }
-    return load_store;
+  if (access.is_oop()) {
+    access.set_barrier_data(access.barrier_data() | ShenandoahBarrierSATB | ShenandoahBarrierCardMark);
   }
   return BarrierSetC2::atomic_cmpxchg_val_at_resolved(access, expected_val, new_val, value_type);
 }
 
 Node* ShenandoahBarrierSetC2::atomic_cmpxchg_bool_at_resolved(C2AtomicParseAccess& access, Node* expected_val,
                                                               Node* new_val, const Type* value_type) const {
+  if (ShenandoahCASBarrier) {
+    set_barrier_data(access);
+  }
   GraphKit* kit = access.kit();
   if (access.is_oop()) {
-    shenandoah_write_barrier_pre(kit, false /* do_load */,
-                                 nullptr, nullptr, max_juint, nullptr, nullptr,
-                                 expected_val /* pre_val */, T_OBJECT);
-    DecoratorSet decorators = access.decorators();
-    MemNode::MemOrd mo = access.mem_node_mo();
-    Node* mem = access.memory();
-    bool is_weak_cas = (decorators & C2_WEAK_CMPXCHG) != 0;
-    Node* load_store = nullptr;
-    Node* adr = access.addr().node();
-#ifdef _LP64
-    if (adr->bottom_type()->is_ptr_to_narrowoop()) {
-      Node *newval_enc = kit->gvn().transform(new EncodePNode(new_val, new_val->bottom_type()->make_narrowoop()));
-      Node *oldval_enc = kit->gvn().transform(new EncodePNode(expected_val, expected_val->bottom_type()->make_narrowoop()));
-      if (ShenandoahCASBarrier) {
-        if (is_weak_cas) {
-          load_store = kit->gvn().transform(new ShenandoahWeakCompareAndSwapNNode(kit->control(), mem, adr, newval_enc, oldval_enc, mo));
-        } else {
-          load_store = kit->gvn().transform(new ShenandoahCompareAndSwapNNode(kit->control(), mem, adr, newval_enc, oldval_enc, mo));
-        }
-      } else {
-        if (is_weak_cas) {
-          load_store = kit->gvn().transform(new WeakCompareAndSwapNNode(kit->control(), mem, adr, newval_enc, oldval_enc, mo));
-        } else {
-          load_store = kit->gvn().transform(new CompareAndSwapNNode(kit->control(), mem, adr, newval_enc, oldval_enc, mo));
-        }
-      }
-    } else
-#endif
-    {
-      if (ShenandoahCASBarrier) {
-        if (is_weak_cas) {
-          load_store = kit->gvn().transform(new ShenandoahWeakCompareAndSwapPNode(kit->control(), mem, adr, new_val, expected_val, mo));
-        } else {
-          load_store = kit->gvn().transform(new ShenandoahCompareAndSwapPNode(kit->control(), mem, adr, new_val, expected_val, mo));
-        }
-      } else {
-        if (is_weak_cas) {
-          load_store = kit->gvn().transform(new WeakCompareAndSwapPNode(kit->control(), mem, adr, new_val, expected_val, mo));
-        } else {
-          load_store = kit->gvn().transform(new CompareAndSwapPNode(kit->control(), mem, adr, new_val, expected_val, mo));
-        }
-      }
-    }
-    access.set_raw_access(load_store);
-    pin_atomic_op(access);
-    if (ShenandoahCardBarrier) {
-      post_barrier(kit, kit->control(), access.raw_access(), access.base(),
-                   access.addr().node(), access.alias_idx(), new_val, T_OBJECT, true);
-    }
-    return load_store;
+    access.set_barrier_data(access.barrier_data() | ShenandoahBarrierSATB | ShenandoahBarrierCardMark);
   }
   return BarrierSetC2::atomic_cmpxchg_bool_at_resolved(access, expected_val, new_val, value_type);
 }
 
 Node* ShenandoahBarrierSetC2::atomic_xchg_at_resolved(C2AtomicParseAccess& access, Node* val, const Type* value_type) const {
-  GraphKit* kit = access.kit();
-  Node* result = BarrierSetC2::atomic_xchg_at_resolved(access, val, value_type);
   if (access.is_oop()) {
-    result = kit->gvn().transform(new ShenandoahLoadReferenceBarrierNode(nullptr, result, access.decorators()));
-    shenandoah_write_barrier_pre(kit, false /* do_load */,
-                                 nullptr, nullptr, max_juint, nullptr, nullptr,
-                                 result /* pre_val */, T_OBJECT);
-    if (ShenandoahCardBarrier) {
-      post_barrier(kit, kit->control(), access.raw_access(), access.base(),
-                   access.addr().node(), access.alias_idx(), val, T_OBJECT, true);
-    }
+    access.set_barrier_data(ShenandoahBarrierStrong | ShenandoahBarrierSATB | ShenandoahBarrierCardMark);
   }
-  return result;
+  return BarrierSetC2::atomic_xchg_at_resolved(access, val, value_type);
 }
 
 
-bool ShenandoahBarrierSetC2::is_gc_pre_barrier_node(Node* node) const {
-  return is_shenandoah_wb_pre_call(node);
-}
-
 bool ShenandoahBarrierSetC2::is_gc_barrier_node(Node* node) const {
-  return (node->Opcode() == Op_ShenandoahLoadReferenceBarrier) ||
-         is_shenandoah_lrb_call(node) ||
-         is_shenandoah_wb_pre_call(node) ||
-         is_shenandoah_clone_call(node);
+  return is_shenandoah_clone_call(node);
 }
 
-Node* ShenandoahBarrierSetC2::step_over_gc_barrier(Node* c) const {
-  if (c == nullptr) {
-    return c;
+static void refine_barrier_by_new_val_type(const Node* n) {
+  if (n->Opcode() != Op_StoreP && n->Opcode() != Op_StoreN) {
+    return;
+  }
+  MemNode* store = n->as_Mem();
+  const Node* newval = n->in(MemNode::ValueIn);
+  assert(newval != nullptr, "");
+  const Type* newval_bottom = newval->bottom_type();
+  TypePtr::PTR newval_type = newval_bottom->make_ptr()->ptr();
+  uint8_t barrier_data = store->barrier_data();
+  if (!newval_bottom->isa_oopptr() &&
+      !newval_bottom->isa_narrowoop() &&
+      newval_type != TypePtr::Null) {
+    // newval is neither an OOP nor null, so there is no barrier to refine.
+    assert(barrier_data == 0, "non-OOP stores should have no barrier data");
+    return;
+  }
+  if (barrier_data == 0) {
+    // No barrier to refine.
+    return;
   }
-  if (c->Opcode() == Op_ShenandoahLoadReferenceBarrier) {
-    return c->in(ShenandoahLoadReferenceBarrierNode::ValueIn);
+  if (newval_type == TypePtr::Null) {
+    // Simply elide post-barrier if writing null.
+    barrier_data &= ~ShenandoahBarrierCardMark;
+    barrier_data &= ~ShenandoahBarrierCardMarkNotNull;
+  } else if ((barrier_data & ShenandoahBarrierCardMark) != 0 &&
+             newval_type == TypePtr::NotNull) {
+    // If the post-barrier has not been elided yet (e.g. due to newval being
+    // freshly allocated), mark it as not-null (simplifies barrier tests and
+    // compressed OOPs logic).
+    barrier_data |= ShenandoahBarrierCardMarkNotNull;
   }
-  return c;
+  store->set_barrier_data(barrier_data);
 }
 
 bool ShenandoahBarrierSetC2::expand_barriers(Compile* C, PhaseIterGVN& igvn) const {
-  return !ShenandoahBarrierC2Support::expand(C, igvn);
-}
-
-bool ShenandoahBarrierSetC2::optimize_loops(PhaseIdealLoop* phase, LoopOptsMode mode, VectorSet& visited, Node_Stack& nstack, Node_List& worklist) const {
-  if (mode == LoopOptsShenandoahExpand) {
-    assert(UseShenandoahGC, "only for shenandoah");
-    ShenandoahBarrierC2Support::pin_and_expand(phase);
-    return true;
+  ResourceMark rm;
+  VectorSet visited;
+  Node_List worklist;
+  worklist.push(C->root());
+  while (worklist.size() > 0) {
+    Node* n = worklist.pop();
+    if (visited.test_set(n->_idx)) {
+      continue;
+    }
+    refine_barrier_by_new_val_type(n);
+    for (uint j = 0; j < n->req(); j++) {
+      Node* in = n->in(j);
+      if (in != nullptr) {
+        worklist.push(in);
+      }
+    }
   }
   return false;
 }
 
 bool ShenandoahBarrierSetC2::array_copy_requires_gc_barriers(bool tightly_coupled_alloc, BasicType type, bool is_clone, bool is_clone_instance, ArrayCopyPhase phase) const {
